import javax.swing.JOptionPane;
import java.io.ObjectOutputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.IOException;

/**
 * Quiz solution for the ObjectInputStream and ObjectOutputStream classes.
 * 
 * @author Prof. Struck
 * @version 12/6/2017
 */
public class ObjectIOStream
{
    /**
     * Input product data from a dialog window, instantiate a StringBuilder object
     * and write the object to an ObjectOutputStream file.
     */
    public static void output()
    {
        try
        {
            StringBuilder builder = new StringBuilder();    
            ObjectOutputStream output = new ObjectOutputStream( new FileOutputStream("product.data") );

            int productID = Integer.parseInt( JOptionPane.showInputDialog("Enter product ID: ") );
            String item = JOptionPane.showInputDialog("Enter item name: ");
            double price = Double.parseDouble( JOptionPane.showInputDialog("Enter price: ") );

            builder.append("Product ID: ");
            builder.append(productID);
            builder.append("\nItem: ");
            builder.append(item);
            builder.append("\nPrice: ");
            builder.append(price);

            output.writeObject(builder);

            output.close();
        }

        catch (NumberFormatException ex)
        {
            JOptionPane.showMessageDialog(null, ex);
        }

        catch (IOException ex)
        {
            JOptionPane.showMessageDialog(null, ex);
        }
    }
    
    /**
     * Instantiate an ObjectInputStream file, read the StringBuilder object from the file
     * and write the object to a dialog window.
     */
    public static void input()
    {
        try
        {
            ObjectInputStream input = new ObjectInputStream( new FileInputStream("builder.data") );
            
            JOptionPane.showMessageDialog(null, input.readObject() );
            
            input.close();  
        }
        
        catch (IOException ex)
        {
            JOptionPane.showMessageDialog(null, ex);
        }
        
        catch (ClassNotFoundException ex)
        {
            JOptionPane.showMessageDialog(null, ex);
        }
    }
}
